#define c0 (mutex[1]@critical)
#define c1 (mutex[2]@critical)
#define t0 (mutex[1]@trying)
#define t1 (mutex[2]@trying)
#define l0 (_last == 1)
#define l1 (_last == 2)

mtype = {MSG};

chan sharing = [1] of {mtype};

proctype mutex() {

    printf("Process %d has started.\n", _pid); 

trying:        
        sharing?MSG;
                
critical:
              skip;
              printf("Process %d entered critical section.\n", _pid);
              
exit:
              sharing!MSG;
              printf("Process %d exited critical section.\n", _pid);

goto trying;

}

init {
    sharing!MSG;
    atomic {
      run mutex();
      run mutex();
    }
}

ltl p1 { []   ! (c0  &&  c1) }
ltl p2 { []((t0 || t1) -> <> (c0 || c1)) }
ltl p3 { ([]<> l0) -> [](t0 -> <>c0)}
